# Changelog

#### v4.7.0

* **Feature:** Improved session information display, now parses browser and OS *2024-04-04*
* **Feature:** Optionally exclude TFA-enabled users from batch update actions *2024-04-04*
* **Change:** Refactored backend code *2024-04-04*
* **Change:** Bump minimum PHP version to 7.4 and recommended version to 8.2 *2024-04-04*
* **Change:** Update dependencies to the latest version(s) *2024-04-04*
* **Fix:** User agent is now updated for login sessions *2024-04-04*
* **Fix:** Bad Behavior would run on PHP versions newer than it supports *2024-04-04*
* **Fix:** Fix PHP 8.2 compatibility issues *2024-04-04*
* **Fix:** Fix PHP 8.4 compatibility issue *2024-04-04*


#### v4.6.8

* **Fix:** Fix Config Tamper watcher producing a server error when running on XenForo Cloud / with certain config.php additions *2024-01-09*


#### v4.6.7

* **Fix:** Fixed an issue where it was possible to delete other users' "Remember Me" records *2023-07-26*


#### v4.6.6

* **Change:** Improve compatibility with databases setup for replication *2023-07-13*


#### v4.6.5

* **Change:** Change UTF-8 related functions *2023-02-01*
* **Fix:** Certain URLs could cause a server error in dispatcherPostRender *2023-02-01*


#### v4.6.4

* **Fix:** The "Always show CAPTCHA when logging in to: front-end" option would not function correctly if the login form was loaded via AJAX *2022-10-07*


#### v4.6.3

* **Fix:** Fix potential server error while upgrading other add-ons *2022-09-24*


#### v4.6.2

* **Fix:** "You must be logged in to do that" pages did not have captcha properly applied on first load *2022-04-12*
* **Fix:** Fix incompatibility with 3rd party add-ons that also extend certain View classes *2022-04-12*
* **Fix:** Using the new XF2 security locking feature in a Security Watcher could fail to apply the lock in certain scenarios *2022-04-12*


#### v4.6.1

* **Fix:** Login captcha no longer applies to password confirmation screens *2022-03-01*


#### v4.6.0

* **Feature:** Account unlocks now add an entry to the IP log *2022-01-27*
* **Feature:** Batch update: Account lock (user unlock) *2022-01-27*
* **Feature:** Optional forced CAPTCHA for front-end and AdminCP logins *2022-01-27*
* **Change:** Account locks (user unlock or admin unlock) are now logged in the User Change Log *2022-01-27*
* **Fix:** Fix potential server errors when viewing certain pages *2022-01-27*
* **Fix:** Fix an issue where the User Information watcher wasn't correctly limiting to the field described in the Watcher Rules *2022-01-27*


#### v4.5.7

* **Fix:** Fix potential server errors when viewing certain pages *2021-12-14*


#### v4.5.6

* **Change:** Switch to a more stable method of updating the country list *2021-11-09*


#### v4.5.5

* **Fix:** Updated the Country API to account for changes in 3rd party services (now requires an API key) *2021-10-06*


#### v4.5.4

* **Fix:** When viewing options from pages other than the "Settings" page, a server error could be generated *2021-07-20*


#### v4.5.3

* **Change:** Expired sessions are now deleted via a Cron job instead of on session start *2021-05-23*


#### v4.5.2

* **Fix:** Hide log entries that do not have a valid Watcher record *2021-02-08*
* **Fix:** Watcher log entries were not removed after a watcher had been deleted *2021-02-08*
* **Fix:** If no security watchers were set up, the cache could be rebuilt repeatedly when this was not needed *2021-02-08*


#### v4.5.1

* **Fix:** Fixed a race condition where the same fingerprint could be inserted twice, generating a server error *2020-10-30*
* **Fix:** Fix a few server errors in the Watcher service *2020-10-30*


#### v4.5.0

* **Fix:** Fix typo in the "Reset password" watcher action *2020-09-30*


#### v4.5.0b1

* **Feature:** The two new "Security lock" features in XenForo 2.2 can now be used as Watcher actions where this makes sense *2020-08-31*
* **Fix:** Fix TOR exit node handling *2020-08-31*
* **Fix:** Handle a 404 response from HIBP *2020-08-31*


#### v4.4.0

* **Feature:** Login session management - Log out of other devices via your Password & Security page *2020-07-23*


#### v4.3.4

* **Fix:** "The following sub-option(s) are unknown: includeWebGL" when saving settings *2020-06-25*
* **Fix:** Fix regression from 4.3.3 affecting fingerprints *2020-06-25*


#### v4.3.3

* **Fix:** Corrected the log phrase for locked accounts (not retroactive) *2020-06-15*
* **Fix:** Ensure the "resend" and "unlock" actions are also excluded from force redirects *2020-06-15*
* **Fix:** Ensure all redirects use the public route (prevents race condition where admin accounts are redirected) *2020-06-15*


#### v4.3.2

* **Feature:** Log "account locked" status in the User Change Log *2020-06-05*
* **Fix:** Fix a potential server during install *2020-06-05*

#### v4.3.1

* **Change:** Updated internal data path references to better support CDNs *2019-12-11*
* **Fix:** Fix curly brace syntax for PHP 7.4 *2019-12-11*
* **Fix:** Fixed an issue where adding a closure / anonymous function to config.php could cause issues with the config tamper detection *2019-12-11*


#### v4.3.0

* **Feature:** Security keys can now be used as a two-step authentication method **[!!!REQUIRES PHP 7.2 OR HIGHER!!!]** *2019-09-19*
* **Feature:** Security keys can now be integrated with password confirm screens **[!!!REQUIRES PHP 7.2 OR HIGHER!!!]** *2019-09-19*
* **Change:** Rename a couple of database columns to ensure they comply with the resource guidelines *2019-09-19*
* **Fix:** Fix a regression with the HIBP API *2019-09-19*


#### v4.2.7

* **Change:** Updated HaveIBeenPwned integration (account breach checker) to use v3 of their API *2019-08-16*


#### v4.2.6

* **Change:** Add protection from invalid responses from various API lookups *2019-08-16*
* **Fix:** Fixed an issue where invalid responses from HaveIBeenPwned would cause a server error *2019-08-16*


#### v4.2.5

* **Fix:** Ensure we don't attempt to json_decode on an empty body *2019-07-15*


#### v4.2.4

* **Change:** Changed the way API calls are made, in order to support the HTTP Proxy feature in XenForo *2019-07-05*
* **Change:** Use FontAwesome for the password rule indicators instead of images *2019-07-05*
* **Fix:** Fix a server error when doing mass password reset *2019-07-05*


#### v4.2.3

* **Fix:** The link to IP address info in the IP Address Search results now works as intended *2019-05-14*
* **Fix:** Fix a bug in the Bad Behavior script *2019-05-14*
* **Fix:** Fix for a possible duplicate entry in the fingerprint log *2019-05-14*


#### v4.2.2

* **Change:** Country blocks are now saved / updated in the background *2019-05-01*


#### v4.2.1

* **Fix:** Fixed an issue where the password rules would break the password box layout *2019-01-30*


#### v4.2.0

* **Change:** Updated various HTTP requests to match the changes in XF 2.1 *2019-01-22*
* **Fix:** Fixed an issue where a template modification would display a server error during an upgrade of this addon. It is safe to ignore that error. *2019-01-22*


#### v4.1.0b3

* **Feature:** Route whitelist feature for the "Account Lock" redirect *2019-01-18*
* **Feature:** Route whitelist for the "Password Change" redirect *2019-01-18*
* **Fix:** Fixed an infinite redirect loop when a user was forced to change their password AND accept privacy policy / terms *2019-01-18*


#### v4.1.0b2

* **Fix:** Fixed an issue where Bad Behavior would cause a server error *2018-12-01*


#### v4.1.0b1

* **Feature:** IP address search now uses XF2's IP log *2018-11-23*
* **Feature:** The "Force Password Change" page now uses the "user search form" to give greater control over whose passwords need changing *2018-11-23*
* **Feature:** The "Mass password reset" page now uses the "user search form" to give greater control over whose passwords are reset *2018-11-23*
* **Feature:** The ".htaccess password generator" has an improved password generator, with more advanced rule options *2018-11-23*
* **Feature:** The "Change log" now uses XF2's change log rather than a custom solution *2018-11-23*
* **Change:** Country Blocking now stores its data in XF2's IP Match table *2018-11-23*
* **Change:** The breach checker now uses XF2's "Rebuild" feature to make it a rebuild job *2018-11-23*
* **Change:** Overhauled the UI for Security Watchers *2018-11-23*
* **Change:** Every log page has a vastly improved UI that works better on mobile devices *2018-11-23*


#### v4.0.1

* **Fix:** Updated the endpoint for the GeoIP "Web service" API *2018-07-05*
