<?php

namespace DBTech\Security\Install;

/**
 * @property \XF\AddOn\AddOn addOn
 * @property \XF\App app
 *
 * @method \XF\Db\AbstractAdapter db()
 * @method \XF\Db\SchemaManager schemaManager()
 * @method \XF\Db\Schema\Column addOrChangeColumn($table, $name, $type = null, $length = null)
 */
trait Upgrade904029970Trait
{
	/**
	 * @param array $stepParams
	 *
	 * @return array|bool
	 */
	public function upgrade904020070Step1(array $stepParams)
	{
		$position = empty($stepParams[0]) ? 0 : $stepParams[0];

		return $this->entityColumnsToJson('DBTech\Security:FingerprintLog', ['components'], $position, $stepParams);
	}

	/**
	 * @param array $stepParams
	 *
	 * @return array|bool
	 */
	public function upgrade904020070Step2(array $stepParams)
	{
		$position = empty($stepParams[0]) ? 0 : $stepParams[0];

		return $this->entityColumnsToJson('DBTech\Security:RecoveryLog', ['breakdown'], $position, $stepParams);
	}

	/**
	 * @param array $stepParams
	 *
	 * @return array|bool
	 */
	public function upgrade904020070Step3(array $stepParams)
	{
		$position = empty($stepParams[0]) ? 0 : $stepParams[0];

		return $this->entityColumnsToJson('DBTech\Security:Snapshot', ['data'], $position, $stepParams);
	}
}