<?php

namespace DBTech\Security\Install;

use XF\Db\Schema\Alter;

/**
 * @property \XF\AddOn\AddOn addOn
 * @property \XF\App app
 *
 * @method \XF\Db\AbstractAdapter db()
 * @method \XF\Db\SchemaManager schemaManager()
 * @method \XF\Db\Schema\Column addOrChangeColumn($table, $name, $type = null, $length = null)
 */
trait Upgrade904039970Trait
{
	/**
	 *
	 * @throws \XF\Db\Exception
	 */
	public function upgrade904030031Step1()
	{
		$this->executeUpgradeQuery("
			INSERT IGNORE INTO `xf_tfa_provider`
				(`provider_id`, `provider_class`, `priority`, `active`)
			VALUES
				('dbtech_security_authn', 'DBTech\\\Security:WebAuthn', 1, 1)
		");
	}

	public function upgrade904030051Step1()
	{
		$sm = $this->schemaManager();

		$sm->alterTable('xf_user_remember', function (Alter $table)
		{
			$table->changeColumn('user_agent')
				->resetDefinition()
				->type('blob')
				->nullable(true)
				->renameTo('dbtech_security_user_agent')
			;
		});

		$sm->alterTable('xf_user_tfa_trusted', function (Alter $table)
		{
			$table->changeColumn('user_agent')
				->resetDefinition()
				->type('blob')
				->nullable(true)
				->renameTo('dbtech_security_user_agent')
			;
		});
	}
}