<?php

namespace DBTech\Security\Install;

/**
 * @property \XF\AddOn\AddOn addOn
 * @property \XF\App app
 *
 * @method \XF\Db\AbstractAdapter db()
 * @method \XF\Db\SchemaManager schemaManager()
 * @method \XF\Db\Schema\Column addOrChangeColumn($table, $name, $type = null, $length = null)
 */
trait Upgrade904059970Trait
{
	/**
	 *
	 * @throws \XF\Db\Exception
	 */
	public function upgrade904050031Step1()
	{
		$defaultValue = [
			'closeForum' => false,
			'emailWebmaster' => false,
			'banIp' => false,
			'banUser' => false,
			'emailUser' => false,
			'lockChange' => false,
			'lockReset' => false,
			'lockUser' => false,
			'adminLockUser' => false
		];

		$items = $this->db()->fetchAll('SELECT * FROM xf_dbtech_security_watcher');
		foreach ($items as $item)
		{
			try
			{
				$actions = \GuzzleHttp\json_decode($item['actions'], true);
			}
			catch (\InvalidArgumentException $e)
			{
				$actions = [];
			}

			$update = false;
			foreach (array_keys($defaultValue) AS $key)
			{
				if (!isset($actions[$key]))
				{
					$update = true;
					$actions[$key] = $defaultValue[$key];
				}
			}

			if ($update)
			{
				$this->query("
					UPDATE xf_dbtech_security_watcher
					SET actions = ?
					WHERE watcher_id = ?
				", [
					\GuzzleHttp\json_encode($actions),
					$item['watcher_id']
				]);
			}
		}
	}
}