<?php

namespace DBTech\Security\Job;

use DBTech\Security\Helper;
use XF\Job\AbstractRebuildJob;

/**
 * Class BreachCheck
 *
 * @package DBTech\Security\Job
 */
class BreachCheck extends AbstractRebuildJob
{
	/**
	 * @param $start
	 * @param $batch
	 *
	 * @return array
	 */
	protected function getNextIds($start, $batch): array
	{
		$db = $this->app->db();

		return $db->fetchAllColumn($db->limit(
			'
				SELECT user_id
				FROM xf_user
				WHERE user_id > ?
				ORDER BY user_id
			',
			$batch
		), $start);
	}

	/**
	 * @param $id
	 */
	protected function rebuildById($id)
	{
		$user = Helper::find(\XF\Entity\User::class, $id, ['Profile']);
		if (!$user)
		{
			return;
		}

		$repo = Helper::repository(\DBTech\Security\Repository\Watcher::class);
		$repo->breachCheck($user);
	}

	/**
	 * @return \XF\Phrase
	 */
	protected function getStatusType(): \XF\Phrase
	{
		return \XF::phrase('users');
	}
}