<?php

namespace DBTech\Security\Option;

use DBTech\Security\Helper;

/**
 * Class Tor
 *
 * @package DBTech\Security\Option
 */
class Tor
{
	protected static bool $triggered = false;

	/**
	 * This can be used as a verification callback to force a tor node rebuild
	 *
	 * @param mixed $value
	 * @param \XF\Entity\Option $option
	 * @return bool
	 */
	public static function triggerTorNodeBanning(&$value, \XF\Entity\Option $option): bool
	{
		if ($option->isInsert())
		{
			return true;
		}

		if (!self::$triggered)
		{
			$banningRepo = Helper::repository(\DBTech\Security\Repository\Banning::class);

			if ($value)
			{
				$banningRepo->rebuildBannedTorIps();
			}
			else
			{
				$banningRepo->removeBannedTorIps();
			}
			self::$triggered = true;
		}

		return true;
	}
}