<?php

namespace DBTech\Security\Pub\Controller;

use XF\Pub\Controller\AbstractController;

/**
 * Class Device
 *
 * @package DBTech\Security\Pub\Controller
 */
class Device extends AbstractController
{
	/**
	 * @return \XF\Mvc\Reply\AbstractReply
	 * @throws \XF\Mvc\Reply\Exception
	 * @throws \XF\PrintableException
	 */
	public function actionForget(): \XF\Mvc\Reply\AbstractReply
	{
		/** @var \DBTech\Security\XF\Entity\User $visitor */
		$visitor = \XF::visitor();

		if ($visitor->user_id)
		{
			$record = $this->assertUserRememberExists($this->filter('remember_id', 'uint'));
			if ($record->user_id == $visitor->user_id)
			{
				$record->delete();
			}
		}

		return $this->redirect($this->buildLink('account/security'));
	}

	/**
	 * @param null|int $id
	 * @param array|string|null $with
	 * @param null|string $phraseKey
	 *
	 * @return \XF\Entity\UserRemember
	 * @throws \XF\Mvc\Reply\Exception
	 */
	protected function assertUserRememberExists(?int $id, $with = null, ?string $phraseKey = null): \XF\Entity\UserRemember
	{
		return $this->assertRecordExists('XF:UserRemember', $id, $with, $phraseKey);
	}
}