<?php

namespace DBTech\Security\Pub\Controller;

use DBTech\Security\Helper;
use XF\Pub\Controller\AbstractController;

/**
 * Class Fingerprint
 *
 * @package DBTech\Security\Pub\Controller
 */
class Fingerprint extends AbstractController
{
	/**
	 * @return \XF\Mvc\Reply\AbstractReply
	 * @throws \XF\PrintableException
	 * @throws \Exception
	 */
	public function actionIndex(): \XF\Mvc\Reply\AbstractReply
	{
		/** @var \DBTech\Security\XF\Entity\User $visitor */
		$visitor = \XF::visitor();

		if ($visitor->user_id)
		{
			$fingerprint = $this->filter('fingerprint', 'str');
			$components = $this->filter('components', 'array');

			$watcherRepo = Helper::repository(\DBTech\Security\Repository\Watcher::class);
			$handler = $watcherRepo->getHandler($visitor->is_staff ? 'newstafffingerprint' : 'newfingerprint', false);

			if ($handler)
			{
				$handler->trigger([
					'fingerprint' => $fingerprint,
					'components' => $components,
					'ipaddress' => $this->request->getIp()
				], $visitor);
			}
		}

		return $this->view(
			\DBTech\Security\Pub\View\Fingerprint::class
		);
	}
}