<?php

namespace DBTech\Security\Pub\Controller;

use XF\Pub\Controller\AbstractController;

/**
 * Class Session
 *
 * @package DBTech\Security\Pub\Controller
 */
class Session extends AbstractController
{
	/**
	 * @return \XF\Mvc\Reply\AbstractReply
	 * @throws \XF\Mvc\Reply\Exception
	 * @throws \XF\PrintableException
	 */
	public function actionDelete(): \XF\Mvc\Reply\AbstractReply
	{
		/** @var \DBTech\Security\XF\Entity\User $visitor */
		$visitor = \XF::visitor();

		if ($visitor->user_id)
		{
			$record = $this->assertSessionExists($this->filter('session_id', 'str'));
			if ($record->user_id == $visitor->user_id)
			{
				$record->delete();
			}
		}

		return $this->redirect($this->buildLink('account/security'));
	}

	/**
	 * @param string|null $id
	 * @param array|string|null $with
	 * @param string|null $phraseKey
	 *
	 * @return \DBTech\Security\Entity\Session
	 * @throws \XF\Mvc\Reply\Exception
	 */
	protected function assertSessionExists(?string $id, $with = null, ?string $phraseKey = null): \DBTech\Security\Entity\Session
	{
		return $this->assertRecordExists('DBTech\Security:Session', $id, $with, $phraseKey);
	}
}