<?php

namespace DBTech\Security\Repository;

use DBTech\Security\Helper;
use XF\Mvc\Entity\Repository;

/**
 * Class UserRemember
 *
 * @package DBTech\Security\Repository
 */
class UserRemember extends Repository
{
	/**
	 * @param \XF\Entity\User|null $user
	 *
	 * @return \XF\Mvc\Entity\AbstractCollection
	 */
	public function getRememberedDevicesForUser(?\XF\Entity\User $user = null): \XF\Mvc\Entity\AbstractCollection
	{
		$user = $user ?: \XF::visitor();

		return Helper::finder('XF:UserRemember')
			->where('user_id', $user->user_id)
			->setDefaultOrder('start_date', 'asc')
			->fetch()
		;
	}
}