<?php /** @noinspection PhpMissingReturnTypeInspection */

namespace DBTech\Security\XF\Admin\Controller;

/**
 * @extends \XF\Admin\Controller\User
 */
class User extends XFCP_User
{
	/**
	 * @param \XF\Entity\User $user
	 *
	 * @return \XF\Mvc\FormAction
	 * @throws \InvalidArgumentException
	 * @throws \XF\Mvc\Reply\Exception
	 */
	protected function userSaveProcess(\XF\Entity\User $user)
	{
		$form = parent::userSaveProcess($user);

		$input = $this->filter([
			'option' => [
				'dbtech_security_is_user_locked' => 'bool',
				'dbtech_security_is_admin_locked' => 'bool'
			],
		]);
		
		$userOptions = $user->getRelationOrDefault('Option');
		$form->setupEntityInput($userOptions, $input['option']);

		return $form;
	}
}