<?php /** @noinspection PhpMissingReturnTypeInspection */

namespace DBTech\Security\XF\Entity;

use XF\Mvc\Entity\Structure;
use XF\Mvc\Entity\Entity;

/**
 * @extends \XF\Entity\UserOption
 */
class UserOption extends XFCP_UserOption
{
	/**
	 * @param \XF\Mvc\Entity\Structure $structure
	 *
	 * @return \XF\Mvc\Entity\Structure
	 * @noinspection PhpMissingReturnTypeInspection
	 */
	public static function getStructure(Structure $structure)
	{
		$structure = parent::getStructure($structure);
		
		$structure->columns['dbtech_security_is_user_locked'] = ['type' => Entity::BOOL, 'default' => false];
		$structure->columns['dbtech_security_is_admin_locked'] = ['type' => Entity::BOOL, 'default' => false];
		
		return $structure;
	}
}