<?php /** @noinspection PhpMissingReturnTypeInspection */

namespace DBTech\Security\XF\Entity;

use XF\Mvc\Entity\Structure;
use XF\Mvc\Entity\Entity;

/**
 * @extends \XF\Entity\UserRemember
 */
class UserRemember extends XFCP_UserRemember
{
	protected function _preSave()
	{
		if (!$this->dbtech_security_user_agent)
		{
			$this->dbtech_security_user_agent = $this->app()->request()->getUserAgent();
		}
	}

	/**
	 * @param \XF\Mvc\Entity\Structure $structure
	 *
	 * @return \XF\Mvc\Entity\Structure
	 * @noinspection PhpMissingReturnTypeInspection
	 */
	public static function getStructure(Structure $structure)
	{
		$structure = parent::getStructure($structure);
		
		$structure->columns['dbtech_security_user_agent'] = ['type' => Entity::STR];
		return $structure;
	}
}