<?php /** @noinspection PhpMissingReturnTypeInspection */

namespace DBTech\Security\XF;

use DBTech\Security\Helper;

/**
 * @extends \XF\Logger
 */
class Logger extends XFCP_Logger
{
	protected ?\DBTech\Security\WatcherLog\Logger $dbtechSecurityWatcherLogger = null;


	/**
	 * @return \DBTech\Security\WatcherLog\Logger
	 * @throws \Exception
	 */
	public function dbtechSecurityWatcherLogger()
	{
		if (!$this->dbtechSecurityWatcherLogger)
		{
			$this->dbtechSecurityWatcherLogger = Helper::newExtendedClass(
				\DBTech\Security\WatcherLog\Logger::class
			);
		}

		return $this->dbtechSecurityWatcherLogger;
	}

	/**
	 * @param \DBTech\Security\Entity\Watcher $content
	 * @param string $action
	 * @param string|null $message
	 * @param array $params
	 * @param bool $throw
	 * @param \XF\Entity\User|null $actor
	 *
	 * @return \DBTech\Security\Entity\WatcherLog|null
	 * @throws \XF\PrintableException
	 * @throws \Exception
	 */
	public function logDbtechSecurityWatcher(
		\DBTech\Security\Entity\Watcher $content,
		string $action,
		?string $message,
		array $params = [],
		bool $throw = true,
		?\XF\Entity\User $actor = null
	) {
		return $this->dbtechSecurityWatcherLogger()->log($content, $action, $message, $params, $throw, $actor);
	}
}