<?php /** @noinspection PhpMissingReturnTypeInspection */

namespace DBTech\Security\XF\Pub\Controller;

use DBTech\Security\Helper;

class Account extends XFCP_Account
{
	/**
	 * @return \XF\Mvc\Reply\AbstractReply
	 * @throws \XF\Db\Exception
	 * @throws \XF\Mvc\Reply\Exception
	 */
	public function actionTwoStepTrustedDisableById()
	{
		$this->assertPostOnly();
		$this->assertTwoStepPasswordVerified();

		/** @var \DBTech\Security\XF\Repository\UserTfaTrusted $tfaTrustRepo */
		$tfaTrustRepo = Helper::repository(\XF\Repository\UserTfaTrusted::class);

		$userId = \XF::visitor()->user_id;

		$tfaTrustRepo->untrustDeviceById($userId, $this->filter('trusted_id', 'uint'));

		return $this->redirect($this->buildLink('account/two-step'));
	}
}